<template>
  <div class="table-container">
    <table class="table is-bordered is-striped is-fullwidth" :class="tableClass">
      <thead>
        <tr>
          <th v-for="(column, columnId) in config.columns" :key="columnId">{{ column.title }}</th>
        </tr>
      </thead>
      <tbody>
        <tr v-if="isEmpty">
          <td :colspan="columnCount">
            <article class="message">
              <div class="message-body">No data to show</div>
            </article>
          </td>
        </tr>
        <tr v-else-if="loading">
          <td :colspan="columnCount">
            <progress class="progress is-small is-primary" max="100">15%</progress>
          </td>
        </tr>
        <tr v-else v-for="row in items" :key="row.id">
          <td v-for="(column, columnId) in config.columns" :key="columnId" @click="onClick(row.id)">{{ row[columnId] }}</td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, computed } from 'vue'

interface ColumnsConfig {
  [key: string]: { title: string }
}

interface RowConfig {
  clickEnabled: boolean
}

interface TableConfig {
  columns: ColumnsConfig
  rows?: RowConfig
}

export default defineComponent({
  name: 'Table',
  props: {
    items: {
      type: Array as PropType<(string | null)[]>,
      required: true,
    },
    config: {
      type: Object as PropType<TableConfig>,
      required: true,
    },
    loading: {
      type: Boolean,
    },
  },
  setup(props, context) {
    const isEmpty = computed(() => props.items.length === 0 && !props.loading)
    const columnCount = computed(() => Object.keys(props.config.columns).length)
    const clickEnabled = computed(() => !!props.config.rows?.clickEnabled)
    const tableClass = computed(() => ({ 'is-hoverable': clickEnabled, 'is-clickable': clickEnabled }))

    const onClick = (id: number) => {
      if (clickEnabled.value) {
        context.emit('rowClick', id)
      }
    }

    return { isEmpty, columnCount, tableClass, onClick }
  },
})
</script>
